;
(declare (usual-integrations))
;
(defstruct sgraph
   graph
   inputs
   outputs
   transitions
   places
   dfs
   eps-places
   esgs
   log
   consider
   consider-esg
   orbit-info
   token-locator
   beh-times
   con-times
   c-lib-r
   b-lib-r
   global-tscale
   local-tscale
   tmax
   tb-assoc
   tc-assoc
   esg-hash
   dead-transition)
;
(defstruct (strans (:include node))
   dirty?
   enabled?
   dead?
   input?
   output?
   much-later?
   eps-connected
   eps-conflicts
   magik
   orbits
   timed-places
   esg-bit
   state-value
   po-stuff-cache
   df-rw          ; this is the list of joins that are read or written
   fired?)
;
;   Note that in this and the next structure, curval must be *first*.
;   This way we can use a place also as a data flow source for those
;   cases where a data flow arc leaves a place.
;
(defstruct (splace (:include node))
   curval   ; must be first!
   marked?
   time-constraint?
   time-marking
   trange-seen
   trange-succeeded
   immediate?
   id
   state-value ; the magik state value for this place
   eps-connected
   wire
   dot-of-p-dot
   orbit-seq
   sort-key)
;
(defstruct (sdf (:include node))
   curval   ; must be first!
   op
   reg?
   state-value
   joins  ; these are the list of joins that this data flow node depends on.
   history ; for joins, this is the history stack of reads/writes
   args)
;
;   Every epsilon subgraph has one of these.
;
(defstruct eps-subgraph
   places
   transitions
   dirty?
   enabled?
   accel
   magik
   state
   serial)
;
;   These are the table entries.
;
(defstruct state
   val
   seq
   dead?
   succ
   utility
   shapes)
;
;   When we use partial order timing, we use these structures.
;
(defstruct po
   level
   index
   covered
   maxcover
   transition
   min-cache
   max-cache
   translate-deltas
   canonical-sequence
   esg-bit
   early-release
;  extreme-frontier
;  state-delta
   )
